
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>httpclient获取响应实体和信息的封装方法（解耦更新） / 憋错料</title>

    <meta name="description" content="httpclient获取响应实体和信息的封装方法（解耦更新） 转自:https://blog.csdn.net/fhaohaizi/article/details/77850302 2018年07月19日更新,主要是解耦之后方法很多地方发生了变化,httpclient用了连接池方式,作为一个静态变量处理,请求头和响应头以及cookies设置都有了相关处理方法,本来这个方法已经快超过100行了,解耦之后分成了几个小方法,方便修改和调试.分两部分,一部分是框架,只做了公共处理,另外一部分是每个项目的base类需要重新实现一些这个方法来处理header信息以及需">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">httpclient获取响应实体和信息的封装方法（解耦更新）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>转自:<a href="https://blog.csdn.net/fhaohaizi/article/details/77850302" rel="external nofollow noreferrer">https://blog.csdn.net/fhaohaizi/article/details/77850302</a></p>
<p>2018年07月19日更新，主要是解耦之后方法很多地方发生了变化，httpclient用了连接池方式，作为一个静态变量处理，请求头和响应头以及cookies设置都有了相关处理方法，本来这个方法已经快超过100行了，解耦之后分成了几个小方法，方便修改和调试。分两部分，一部分是框架，只做了公共处理，另外一部分是每个项目的base类需要重新实现一些这个方法来处理header信息以及需要特殊处理的地方。分享代码如下：</p>
<pre>/**
     * 获取响应实体
     *
     * @param request 请求对象
     * @return 返回json类型的对象
     */
    protected static JSONObject getHttpResponse(HttpRequestBase request) {
        beforeRequest(request);
        JSONObject jsonObject = new JSONObject();
        RequestInfo requestInfo = new RequestInfo(request);
        CloseableHttpResponse response = null;// 创建响应对象
        Date start = getDate();// 记录开始时间
        try {
            response = ClientManage.httpsClient.execute(request);
        } catch (Exception e) {
            new Thread(() -&gt; new AlertOver("接口请求失败", requestInfo.toString() + Arrays.toString(e.getStackTrace()), requestInfo.getUrl()).sendSystemMessage()).start();
            return jsonObject;
        }
        Date end = getDate();// 记录结束时间
        double elapsed_time = getTimeDiffer(start, end);// 获取响应耗时
        afterResponse(response);
        int status = response.getStatusLine().getStatusCode();// 获取响应状态
        String content = getContent(response);
        long data_size = content.length();
        jsonObject = getResponse(content);
        int code = checkCode(jsonObject, requestInfo.getUrl());
        if (status != HttpStatus.SC_OK)
            new Thread(() -&gt; new AlertOver("响应状态码错误", "状态码错误：" + status, requestInfo.getUrl()).sendSystemMessage());
        MySqlTest.saveApiTestDate(requestInfo, data_size, elapsed_time, status, getMark(), code, LOCAL_IP, COMPUTER_USER_NAME);
        return jsonObject;
    }</pre>
<p>下面是里面封装方法的依次分享：</p>
<pre>/**
     * 发送请求之前，配置请求管理器，设置IP，user_agent和cookie
     *
     * @param request
     */
    private static void beforeRequest(HttpRequestBase request) {
        request.setConfig(requestConfig);//设置请求配置
        request.addHeader(getHeader("X-FORWARDED-FOR", getRandomIP()));//随机生成ip
        request.addHeader(HTTP.USER_AGENT, USER_AGENT);
        if (cookies != null &amp;&amp; !Arrays.toString(request.getAllHeaders()).contains(REQUEST_HEADER_COOKIE))
            request.addHeader(REQUEST_HEADER_COOKIE, cookies);// 添加cookie
    }</pre>
<p>requestinfo类的方法：</p>
<pre>package com.fission.source.httpclient;

import com.fission.source.source.SourceCode;
import lombok.Data;
import org.apache.http.HttpEntity;
import org.apache.http.ParseException;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpRequestBase;
import org.apache.http.util.EntityUtils;

import java.io.IOException;

/**
 * 请求信息封装类
 */
@Data
public class RequestInfo extends SourceCode {
    /**
     * 接口地址
     */
    String apiName;
    /**
     * 请求的url
     */
    String url;
    /**
     * 请求的uri
     */
    String uri;
    /**
     * 方法，get/post
     */
    String method;
    /**
     * 域名
     */
    String host;
    /**
     * 协议类型
     */
    String type;
    /**
     * 参数
     */
    String params;

    /**
     * 通过request获取请求的相关信息，并输出部分信息
     *
     * @param request
     */
    public RequestInfo(HttpRequestBase request) {
        getRequestInfo(request);
        if (!host.contains("alertover") &amp;&amp; !host.contains("lonelymind"))
            output(TAB + TAB + TAB + "请求uri：" + uri + LINE + TAB + TAB + TAB + "请求参数是：" + params);
    }

    /**
     * 封装获取请求的各种信息的方法
     *
     * @param request 传入请求对象
     * @return 返回一个map，包含api_name,host_name,type，method，params
     */
    private void getRequestInfo(HttpRequestBase request) {
        method = request.getMethod();// 获取method
        uri = request.getURI().toString();// 获取uri
        getRequestUrl(uri);
        String one = url.substring(url.indexOf("//") + 2);// 删除掉http://
        apiName = one.substring(one.indexOf("/"));// 获取接口名
        host = one.substring(0, one.indexOf("/"));// 获取host地址
        type = url.substring(0, url.indexOf("//") - 1);// 获取协议类型
        if (method.equals(REQUEST_TYPE_GET)) {
            params = uri.substring(uri.indexOf("?") + 1, uri.length());
        } else if (method.equals(REQUEST_TYPE_POST)) {
            getPostRequestParams(request);
        }
    }

    /**
     * 获取请求url，遇到get请求，先截取
     *
     * @param uri
     */
    private void getRequestUrl(String uri) {
        url = uri;
        if (uri.contains("?")) url = uri.substring(0, uri.indexOf("?"));
    }

    /**
     * 获取post请求的参数
     *
     * @param request
     */
    private void getPostRequestParams(HttpRequestBase request) {
        HttpPost httpPost = (HttpPost) request;// 强转httppost请求
        HttpEntity entity = httpPost.getEntity();// 获取实体
        if (entity == null) return;
        try {
            params = EntityUtils.toString(entity);// 解析实体
            EntityUtils.consume(entity);// 确保实体消耗
        } catch (UnsupportedOperationException e) {
            params = "entity类型：" + entity.getClass();
        } catch (ParseException e) {
            output("解析响应实体异常！", e);
        } catch (IOException e) {
            output("解析响应实体时java IO 异常！", e);
        }
    }
}</pre>
<pre>/**
     * 响应结束之后，处理响应头信息，如set-cookien内容
     *
     * @param response
     */
    private static void afterResponse(CloseableHttpResponse response) {
        if (response == null) return;
        List&lt;Header&gt; headers = Arrays.asList(response.getHeaders("Set-Cookie"));
        if (!headers.equals(new ArrayList&lt;&gt;())) setCookies(headers);
        if (cookieSet == false &amp;&amp; cookies != null)
            cookieSet = true;
    }</pre>
<pre>/**
     * 根据响应获取响应实体
     *
     * @param response
     * @return
     */
    private static String getContent(CloseableHttpResponse response) {
        HttpEntity entity = response.getEntity();// 获取响应实体
        String content = EMPTY;
        try {
            content = EntityUtils.toString(entity, UTF_8);// 用string接收响应实体
            EntityUtils.consume(entity);// 消耗响应实体，并关闭相关资源占用
            if (response != null) response.close();
        } catch (ParseException e1) {
            output("解析响应实体异常！", e1);
        } catch (IOException e1) {
            output("解析响应实体时java IO 异常！", e1);
        }
        return content;
    }</pre>
<pre>    /**
     * 根据解析好的content，转化json对象
     *
     * @param content
     * @return
     */
    private static JSONObject getResponse(String content) {
        JSONObject jsonObject = new JSONObject();
        try {
            jsonObject = JSONObject.fromObject(content);
        } catch (Exception e) {
            jsonObject.put("content", content);
            jsonObject.put("code", TEST_ERROR_CODE);
        }
        return jsonObject;
    }</pre>
<pre>    /**
     * 获取并检查code
     *
     * @param jsonObject
     * @param url
     * @return
     */
    private static int checkCode(JSONObject jsonObject, String url) {
        int code = TEST_ERROR_CODE;
        try {
            code = jsonObject.getInt("code");
            if (ERROR_CODE_LIST.contains(code))
                new Thread(() -&gt; new AlertOver("responseCode错误", jsonObject.toString(), url).sendSystemMessage());
        } catch (Exception e) {
            output("响应非标准响应体！", e);
        }
        return code;
    }</pre>
<p>其中数据库存储的和发送提醒消息的这里就不说了，数据库一部存储还在优化，alertover使用方法在其他文章分享过了。</p>
<p>------------------------------------分割线--------------------------------------</p>
<p>本人在使用httpclient做接口测试的时候，需要统计一下接口的一些信息，在写用例的过程中为了提高复用，简化一些结构，所以封装了一些基本方法，分享一下获取响应实体和响应信息的方法，共大家参考。</p>
<pre>//获取post响应，暂无header设置
    public JSONObject getHttpResponseEntityByJson(CloseableHttpClient httpClient, HttpPost httpPost) throws ClientProtocolException, IOException, SQLException, JSONException {
        //在请求中明确定义不要进行压缩
//        httpPost.setHeader("Accept-Encoding", "identity");
        HttpResponse response = null;//创建响应对象
        long date_size = 0;//用于存放数据大小
        String api_name = getApiName(httpPost);//获取接口名称
        String type = getProtocolType(httpPost);//获取协议类型
        String host_name = getHostName(httpPost);//获取hsot主机名称
        Date start = getDate();//记录开始时间
        response = httpClient.execute(httpPost);//获取响应
        Date end = getDate();//记录结束时间
        double elapsed_time= outputTimeDiffer(start, end, "接口：" + api_name);//获取响应耗时
        int status = response.getStatusLine().getStatusCode();//获取响应状态
        if (status == HttpStatus.SC_OK) {//判断一下返回状态
            output("host:" + host_name, "接口："+ api_name + "请求成功！");
            } else {
                output(response.getStatusLine().getStatusCode() + LINE + "请求失败！");
            }
        HttpEntity entity = response.getEntity();//获取响应实体
        data_size = entity.getContentLength();//获取相应数据大小
        if (data_size == -1) {//如果为-1，则重置date_size
            date_size = 0;
        }
        String content = EntityUtils.toString(entity);//解析响应
        if (date_size == 0) {//如果被重置或者没有获取到，则date_size等于解析string大小
            date_size = content.length();
        }
        JSONObject jsonObject = new JSONObject(content);//转换json
        LocalMySql.getInstance().saveApiTestDate(host_name, api_name, date_size, elapsed_time, status, type);
//        httpClient.close();//关闭客户端
        return jsonObject;
    }
    //获取get接口响应，暂无header设置
    public JSONObject getHttpResponseEntityByJson(CloseableHttpClient httpClient, HttpGet httpGet) throws ClientProtocolException, IOException, JSONException, SQLException {
        //在请求中明确定义不要进行压缩
//        httpGet.setHeader("Accept-Encoding", "identity");
        HttpResponse response = null;
        long date_size = 0;
        String api_name = getApiName(httpGet);
        String type = getProtocolType(httpGet);
        Date start = getDate();
        response = httpClient.execute(httpGet);
        Date end = getDate();
        double elapsed_time= outputTimeDiffer(start, end, "接口:" + api_name);
        String host_name = getHostName(httpGet);
        int status = response.getStatusLine().getStatusCode();
        if (status == HttpStatus.SC_OK) {//判断一下返回状态
            output("host:" + host_name, "接口："+ api_name + "请求成功！");
            } else {
                output(response.getStatusLine().getStatusCode() + LINE + "请求失败！");
            }
        HttpEntity entity = response.getEntity();
        data_size = entity.getContentLength();
        if (data_size == -1) {
            date_size = 0;
        }
        String content = EntityUtils.toString(entity);
        if (date_size == 0) {
            date_size = content.length();
        }
        JSONObject jsonObject = new JSONObject(content);
        LocalMySql.getInstance().saveApiTestDate(host_name, api_name, date_size, elapsed_time, status, type);
//        httpClient.close();
        return jsonObject;
    }</pre>
<p>中间使用了本地数据库，将收集的信息存入本地数据库里面，以便以后统计。代码如下：</p>
<pre>    //保存接口测试数据的方法
    public void saveApiTestDate(String host_name, String api_name, long date_size, double elapsed_time, int status, String type) throws SQLException {
        getConnection();
        if (!connection.isClosed()) {
            outputSuccess();
            Statement statement = connection.createStatement();
            String sql = "INSERT INTO api_result (host_name,api_name,date_size,elapsed_time,status,type) VALUES (‘"+host_name+"‘,‘"+api_name+"‘,"
            +date_size+","+ elapsed_time + "," + status + ",‘" + type +"‘);";
//            output(sql);
            statement.executeUpdate(sql);
        }
    }</pre>
<p>中间用到了一些自己封装的方法：</p>
<pre>    //获取json数据中的相应值
    public String getJsonValue(String jsonString, String key) throws JSONException {
        String JsonValue = null;
        if (jsonString == null || jsonString.trim().length() &lt; 1) {//排除为空和空格
            return null;
            }
        JSONObject obj1 = new JSONObject(jsonString);
        JsonValue = (String) obj1.getString(key);
        return JsonValue;//返回对应值
    }
    //获取json数据中的相应值
    public String getJsonValue(JSONObject jsonObject, String key)    {
        String JsonValue = "&middot;&middot;-&middot;";
        try {
            JsonValue = (String) jsonObject.getString(key);
        } catch (JSONException e) {
            output("json数据错误！");
            output(e.toString());
        }
        return JsonValue;//返回对应值
    }
    //把json数据转化为参数
    public String changeJsonToArguments(JSONObject argument) {
        String one = argument.toString();
           String two ="?" + one.substring(1, one.length()-1).replace(",", "&amp;").replace(":", "=").replace("\"", "");
           return two;
           }
    //获取接口名称
    public String getApiName(HttpGet httpGet) {
        String url = getUrl(httpGet);
        String apiName = url.substring(url.indexOf("m/") + 1);
        return apiName;
    }
    //获取接口名称
    public String getApiName(HttpPost httpPost) {
        String url = getUrl(httpPost);
        String apiName = url.substring(url.indexOf("m/") + 1);
        return apiName;
    }
    //获取host名称
    public String getHostName(HttpPost httpPost) {
        String url = getUrl(httpPost);
        String host = url.substring(url.indexOf("//") + 2, url.indexOf("m/") + 2);
        return host;
    }
    //获取host名称
    public String getHostName(HttpGet httpGet) {
        String url = getUrl(httpGet);
        String host = url.substring(url.indexOf("//") + 2, url.indexOf("m/") + 2);
        return host;
    }
    //获取url
    public String getUrl(HttpGet httpGet) {
        String uri = httpGet.getURI().toString();
        String url = uri.substring(0, uri.indexOf("?"));
        return url;
    }
    //获取url
    public String getUrl(HttpPost httpPost) {
        String url = httpPost.getURI().toString();
        if (url.contains("?")) {
            url = url.substring(0, url.indexOf("?"));
        }
        return url;
    }
    //获取协议类型
    public String getProtocolType(HttpGet httpGet) {
        String uri = httpGet.getURI().toString();
        String type = uri.substring(0, uri.indexOf("//") - 1);
        return type;
    }
    //获取协议类型
    public String getProtocolType(HttpPost httpPost) {
        String uri = httpPost.getURI().toString();
        String type = uri.substring(0, uri.indexOf("//") - 1);
        return type;
    }
    //输出json
    public void output(JSONObject jsonObject) {
        String info = jsonObject.toString().replaceAll(",", LINE);
        output(info);
    }</pre>

<p>原文地址：https://www.cnblogs.com/yadongliang/p/9665536.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 08:50:27 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/ref/" title="ref">ref</a>, <a href="https://www.biecuoliao.com/tag/%e5%ae%9e%e7%8e%b0/" title="实现">实现</a>, <a href="https://www.biecuoliao.com/tag/pos/" title="pos">pos</a>, <a href="https://www.biecuoliao.com/tag/index/" title="index">index</a>, <a href="https://www.biecuoliao.com/tag/sys/" title="sys">sys</a>, <a href="https://www.biecuoliao.com/tag/result/" title="result">result</a>, <a href="https://www.biecuoliao.com/tag/cookie/" title="cookie">cookie</a>, <a href="https://www.biecuoliao.com/tag/%e5%a4%8d%e7%94%a8/" title="复用">复用</a>, <a href="https://www.biecuoliao.com/tag/lse/" title="lse">lse</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>httpclient获取响应实体和信息的封装方法（解耦更新）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPW28v4.html" rel="bookmark">Android  使用retrofit时&comma;怎样获取响应的头信息</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这个问题,我前段时间在项目中使用Retrofit遇到过,最后查到的解决办法有两种获取Response Headers的方法,第一种是直接在定义接口是让接口返回Retrofit的Response对象,在Response对象中可以获取到Headers,如: @GET(&quot;/****act=****&quot;) Response&lt;SomeClass&gt; getSomeData(); 在操作Response对象时,使用response.headers():得到Headers. 这样做需要修改所			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41yw6v4.html" rel="bookmark">Android实现获取应用程序相关信息列表的方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文所述为Androdi获取手机应用列表的方法,比如获取到Android应用的软件属性.大小和应用程序路径.应用名称等,获取所有已安装的Android应用列表,包括那些卸载了的,但没有清除数据的应用程序,同时在获取到应用信息的时候,判断是不是系统的应用程序,这是一个应用管理器所必需具备的功能. 具体实现代码如下: ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YQp7q0.html" rel="bookmark">获取jar包版本信息的简单方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天把一个java项目转换成maven项目的时候,发现有些包信息不明确,在porm中添加中无法确定哪一个才是我们需要对的. 以Gson为例,拿到我们需要的信息. 用解压软件打开后,能看到一个叫META-INF的目录.在META-INF文件夹下,找到 MANIFEST.MF文件,就能找到我们需要的信息. 如上.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEB6vP0.html" rel="bookmark">springboot 采用HttpClient获取天气预报 异常及原因</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				采用httpClient调用天气预报地址获取出现异常 2018-10-04 15:18:25.815 ERROR 10868 --- [nio-8080-exec-5] o.a.c.c.C.[.[.[/].[dispatcherServlet] : Servlet.service() for servlet [dispatcherServlet] in context with path [] threw exception [Request processing failed; nested			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wYpwRM.html" rel="bookmark">HttpClient获取数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				HttpClient 是Apache Jakarta Common 下的子项目,可以用来提供高效的.最新的.功能丰富的支持 HTTP 协议的客户端编程工具包,并且它支持 HTTP 协议最新的版本和建议.如果只是需要向Web站点的某个简单页面提交请求并获取服务器响应,HttpURLConnection完全可以胜任.但在绝大部分情况下,Web站点的网页可能没这么简单,这些页面并不是通过一个简单的URL就可访问的,可能需要用户登录而且具有相应的权限才可访问该页面.在这种情况下,就需要涉及Session			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kKrgp0.html" rel="bookmark">JAVA--利用HttpClient模拟浏览器登陆请求获取响应的Cookie</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在通过java采集网页数据时,我们常常会遇到这样的问题: 站点需要登陆才能访问 而这种网站,一般都会对请求进行账号密码的验证,验证的方式也有多种,需要具体分析. 今天分析其中的一种情况: 站点对登陆密码进行动态加密,作为Cookie响应给客户端,之后的请求需要携带加密后的密码进行访问 登陆成功的响应头如下图: 之后的请求头: 因为每次登陆生成一个新的加密密码,所以之前的密码会失效 所以,需要在每次采集之前,先模拟登陆获取响应的密码,再作为cookie继续请求,我们选择采用HttpClient模拟			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49GEbJ0.html" rel="bookmark">WMI 获取硬件信息的封装函数与获取联想台式机的出厂编号方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:WMI 获取硬件信息的封装函数与获取联想台式机的出厂编号方法 今天玩了一把WMI,查询了一下电脑的硬件信息,感觉很多代码都是可以提取出来的,就自己把那些公共部分提出出来,以后如果要获取 某部分的硬件信息就不用写一个一个的函数,比如获取MAC地址就写一个获取MAC地址的函数,获取CPU 信息就写一个获取CPU信息的 函数,太麻烦了 如下是函数代码: 1 private static string identifier(string wmiClass, string wmiProperty,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLmY6A0.html" rel="bookmark">AFNetworking 2&period;0获取响应头信息</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/dengbin9009/article/details/43304813 前文有提到在初始化的时候可以设置Http的头信息,这没有任何问题,但是在笔者使用过程中,时常是要获取Http返回的一些头信息,在初次用AFNetworking2.0新特性NSURLSessionDataTask的时候,为了获取返回的头信息,搞了两个晚上,先是度娘,谷歌,StackOverflow,然后各种那个群找人,嘴壶问同事找大神,最后都说没有用过.就在想要放弃,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dzqNr4.html" rel="bookmark">Jsoup&plus;HttpClient获取新浪新闻数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package com.test; import java.io.IOException; import java.net.URI; import org.apache.http.Header; import org.apache.http.HttpEntity; import org.apache.http.HttpResponse; import org.apache.http.client.ClientProtocolException; import org.apache.http.cl			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/AMDdvnM.html" rel="bookmark" class="title">微信接口校验</a>
					<div>
						1.Servlet package com.itmayiedu.servlet; import java.io.IOException;import java.io.PrintWriter;impor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wrVB10.html" rel="bookmark" class="title">第二层EtherChannel</a>
					<div>
						1.   配置交换机端口到channel group成员之前,必须确保这些端口都是相同配置,不然channelgroup无法把端口绑到一起. 2.   在端口设置模式 channel-group 1  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Adaoy3.html" rel="bookmark" class="title">物联网建设中通讯互联层的终极解决方案</a>
					<div>
						1.自我介绍 本人已经工作10年,一直在工业领域.在一线干过实施,下过矿井:干过项目,带过团队:干过软件研发,出过产品:干过项目群管理,售前和市场也接触过:期间在纯软件公司也干过将近两年的时间,熟悉软 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZAaQl0.html" rel="bookmark" class="title">ylbtech-LanguageSamples-Security&lpar;安全&rpar;</a>
					<div>
						ylbtech-Microsoft-CSharpSamples:ylbtech-LanguageSamples-Security(安全) 1.A,Security 示例(Sample) 返回顶部 “安 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NaREV3.html" rel="bookmark" class="title">PythonS12-day4学习笔记</a>
					<div>
						# 迭代器.装饰器.生成器 # 迭代器 li = [1, 3, 'he', '&amp;'] n = iter(li) print(n.__next__()) import os, sys # 生成器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35qO2E3.html" rel="bookmark" class="title">oracle表名、字段名等对象的命名长度限制</a>
					<div>
						原创作品,出自 &quot;深蓝的blog&quot; 博客,欢迎转载,转载时请务必注明出处,否则追究版权法律责任. 深蓝的blog:http://blog.csdn.net/huangyanlong ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmOxNX3.html" rel="bookmark" class="title">android-Animation-&amp;lt&semi;十二&amp;gt&semi;</a>
					<div>
						1Animations 它是指显示的动画效果,这些效果可以应用在绝大多数的控件里. 2Animations的分类 第一类:Tweened Animations 该类Animations提供了旋转(Ro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MylobE4.html" rel="bookmark" class="title">JavaEE 技术选型建议，服务器配置，部署策略</a>
					<div>
						基础设施环境 # 整体采用 centos6.5 + nginx + tomcat7.0 负载均衡:nginx 配置,使用 nginx 作为负载均衡,权重配置, 在web层做到水平扩展. 以及配置日志格 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41Bm8OM.html" rel="bookmark" class="title">用Xposed框架拦截Android操作系统的短信接收</a>
					<div>
						短信接收原理 关于Android操作系统短信的接收和发送流程的文章网上有一大堆,但是真正说得很清楚的不多,这篇blog写得不错.其实要想真正弄懂Android操作系统短信的流程,还是Linus的那句话 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KBAomM.html" rel="bookmark" class="title">如何使用GitLab和Rancher构建CI&sol;CD流水线&ndash;Part 1</a>
					<div>
						介绍 GitLab核心是集成管理Git存储库的工具.比如你希望创建一个提供服务的平台,那么GitLab将提供强大的身份验证和授权机制.工作组.问题跟踪.wiki和片段,除此之外还有公有.内部和私有存储 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Nq2663.html" rel="bookmark" class="title">fzu 1962 树状数组</a>
					<div>
						优雅的树状数组!人们发明了复杂度为logn的求解第k小的方法,常数小且代码量小,实在是用来求解本类题目的最佳方法,可惜的是我的Treap超时了...... 1 #include &lt;iostrea ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41zoevM.html" rel="bookmark" class="title">easyui datagrid自己定义操作列</a>
					<div>
						通过formatter方法给Jquery easyui 的datagrid 每行添加操作链接 我们都知道Jquery的EasyUI的datagrid能够加入而且自己定义Toolbar. 这样我们选择一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MymnpnM.html" rel="bookmark" class="title">Google开源自然语言解析模型SyntaxNet</a>
					<div>
						Google宣布开源新的自然语言解析模型SyntaxNet.作为TensorFlow开源机器学习库的一部分,SyntaxNet可被用于自动解析语句.Google同时宣布了一个英语语句预先训练的模型Pa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JdApQ0.html" rel="bookmark" class="title">Drupal、IoT 和开源硬件之间的交集</a>
					<div>
						导读 来认识一下Amber Matz,她是来自 Lullabot Education 旗下的Drupalize.Me的产品经理以及培训师.当她没有倒腾 Arduino.Raspberry Pi 以及电 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGAEOo3.html" rel="bookmark" class="title">关于Win7 64位系统通过ODBC访问Access的一点经验</a>
					<div>
						最近趁着工作相对清闲,把电脑的操作系统重装了,由原来的XP换成了Win7(64位),结果遇到一系列的应用数据访问问题. 问题1:自己用VS2010编写的很多小程序在Win7下运行出现错误,经过核实,出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kNRXlM.html" rel="bookmark" class="title">强烈推荐：240多个jQuery插件</a>
					<div>
						概述 jQuery 是继 prototype 之后又一个优秀的 Javascript 框架.其宗旨是—写更少的代码,做更多的事情.它是轻量级的 js 库(压缩后只有21k) ,这是其它的 js 库所不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZQYPq0.html" rel="bookmark" class="title">算法导论  第六章  思考题 6-3   d叉堆</a>
					<div>
						d叉堆的实现相对于二叉堆变化不大,首先看它如何用数组表示. 考虑一个索引从1开始的数组,一个结点i最多可以有d个子结点,编号从id - (d - 2) 到 id + 1. 从而可以知道一个结点i的父结 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02XoDR4.html" rel="bookmark" class="title">Linux 查看CPU信息、机器型号等硬件信息&lbrack;转&rsqb;</a>
					<div>
						查看CPU信息(型号) # cat /proc/cpuinfo | grep name | cut -f2 -d: | uniq -c       8  Intel(R) Xeon(R) CPU    ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Op8dX4.html" rel="bookmark" class="title">补8&period;python之面相对象part&period;7（类相关函数的补充）</a>
					<div>
						一,isinstance(obj.cls) &amp; issubclass(sub,super) isinstance(obj.cls):用于检查一个对象是否属于某个类.(某个对象是否由某个类产生) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rQ8Gg0.html" rel="bookmark" class="title">Android之布局属性</a>
					<div>
						1) 布局的相关属性 ① android:layout_weight=&quot;1.0&quot;,layout_weight 用于给一个线性布局中的诸多视图重要度赋值.所有的视图都有一个layou ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
